SystemOrganization addCategory: #TP_DragonBallZ!

Object subclass: #Bueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

Object subclass: #Guerrero
	instanceVariableNames: 'nivelDePelea CantEnergia puntosDeVida bando semillas aliados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 00:52'!
agregarAliado: unGuerrero.
      self aliados add: unGuerrero.
! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 00:36'!
aliados
	^ aliados! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 00:36'!
aliados: anObject
	aliados := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'Daniel 11/6/2013 00:20'!
aliadosVivos: unGuerrero
 aliados inject: 0 into: [:cantidad :aliado | cantidad +  (unGuerrero estaFueraDeCombate) not ]! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 00:50'!
aliarseCon: unGuerrero.
   ((self puedeAliarseCon: unGuerrero) & (unGuerrero puedeAliarseCon: self))  
                  ifTrue: [ (self agregarAliado: unGuerrero) & (unGuerrero agregarAliado: self )]
                  ifFalse: [ self error: ' No se puede aliar'].
! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/6/2013 15:57'!
aprenderPoder: unPoder 
          ((self poderes includes: unPoder ) not ) poderes add: unPoder.
 ! !

!Guerrero methodsFor: 'accessing' stamp: 'Daniel 11/6/2013 00:25'!
atacarA: unGuerrero 
! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
bando
	^ bando! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
bando: anObject
	bando := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
cantEnergia
	^ CantEnergia! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
cantEnergia: anObject
	CantEnergia := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 01:03'!
comeUnaSemilla
  (self puedeComerUnaSemilla) 
                ifTrue: [^ self recuperate] 
                ifFalse: [self error: 'No puede tomar una semilla del ermitao']. ! !

!Guerrero methodsFor: 'accessing' stamp: 'Daniel 11/5/2013 20:32'!
estaFueraDeCombate: UnGuerrero 
self cantEnergia = 0.! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/6/2013 15:30'!
estaMoribundo: unGuerrero
            self cantEnergia <= 50! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 01:06'!
extraRecuperacion 
     self subclassResponsibility.
! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 00:59'!
hayUnaOMasSemillas
    (self semillas size > 0) IfTrue: [^true]. ! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
nivelDePelea
	^ nivelDePelea! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
nivelDePelea: anObject
	nivelDePelea := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/6/2013 15:30'!
pedirEnergia: unGuerrero 
            aliados select: [:aliado| aliado AliadosNecesariosPoderColectivo]! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/6/2013 15:31'!
perdeEnergia: n
      self cantEnergia - n! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 00:56'!
puedeComerUnaSemilla
     ((self cantEnergia < 200) & (self tieneUnaSemilla)) IfTrue: [^ true].! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
puntosDeVida
	^ puntosDeVida! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
puntosDeVida: anObject
	puntosDeVida := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 01:11'!
recuperate 
      self puntosDeVida: 1000.
      self cantEnergia: self cantEnergia + (0.05 * self nivelDePelea ) + self extraRecuperacion.

 ! !

!Guerrero methodsFor: 'accessing' stamp: 'Daniel 11/5/2013 20:36'!
revivir: unGuerrero! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
semillas
	^ semillas! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/4/2013 23:44'!
semillas: anObject
	semillas := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/6/2013 15:38'!
sumaNivelesDePelea: unGuerrero
    ^ (self aliados inject: self nivelDePelea  into: [: acum : unAliado | acum + unAliado nivelDePelea  ] ).! !

!Guerrero methodsFor: 'accessing' stamp: 'Roman 11/5/2013 00:57'!
tieneUnaSemilla
   (self hayUnaOMasSemillas) IfTrue: [^true] ifFalse: [^false].
! !

Guerrero subclass: #Moustro
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Moustro methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 22:53'!
bando: unGuerrero
^ bando := 'malos'.! !

!Moustro methodsFor: 'as yet unclassified' stamp: 'Roman 11/5/2013 01:08'!
extraRecuperacion 
       ^0.
! !

!Moustro methodsFor: 'as yet unclassified' stamp: 'Roman 11/5/2013 00:02'!
puedeAliarseCon: unGerrero
  ^true.
! !

Guerrero subclass: #Saiayin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Saiayin methodsFor: 'as yet unclassified' stamp: 'Roman 11/5/2013 01:16'!
extraRecuperacion 
   	|extra|
	   ^extra := (100 * (self aliados size)) + self cantEnergia.
	   
       
! !

!Saiayin methodsFor: 'as yet unclassified' stamp: 'Roman 11/5/2013 00:36'!
puedeAliarseCon: unGuerrero.
   (self nivelDePelea > unGuerrero sumaNivelesDePelea) IfTrue: [^true].! !

Guerrero subclass: #Terricola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 22:52'!
bando: unGuerrero
^ bando := 'buenos'.! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'Roman 11/5/2013 00:31'!
esAliadoDe: unGuerrero.
    ((self bando == unGuerrero bando) & 
    ( ( (self aliados select: [: unAliado | unAliado nivelDePelea < 15000] ) size  < 5) | 
        ( unGuerrero nivelDePelea >=15000))).! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'Roman 11/5/2013 01:12'!
extraRecuperacion 
   ^ 200.! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'Roman 11/5/2013 00:05'!
puedeAliarseCon:unGuerrero
    (self esAliadoDe: unGuerrero) IfTrue: [^true].
! !

Object subclass: #Malo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

Object subclass: #Poder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

Poder subclass: #Colectivos
	instanceVariableNames: 'u'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Colectivos methodsFor: 'as yet unclassified' stamp: 'Roman 11/6/2013 15:42'!
aliadosNecesariosPoderColectivo: unPoder
      ^ self cantidadAliados! !

!Colectivos methodsFor: 'as yet unclassified' stamp: 'Daniel 11/6/2013 00:00'!
loPuedeReutilizar: unGuerrero
unGuerrero cantEnergia >= 200  & unGuerrero aliadosVivos >= u! !

!Colectivos methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 23:50'!
puntosDeAtaque: unGuerrero 
^ unGuerrero pedirEnergia + 200! !

Poder subclass: #Liviano
	instanceVariableNames: 'puntos unValor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Liviano methodsFor: 'as yet unclassified' stamp: 'Roman 11/6/2013 15:42'!
puntosDeAtaque: unGuerrero 
         ^ puntos := unValor! !

!Liviano methodsFor: 'as yet unclassified' stamp: 'Roman 11/6/2013 15:43'!
sacarEnergiaDe: unGuerrero
              ^ 0.! !

!Poder methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 23:24'!
puntosDeAtaque: unPoder
self subclassResponsibility.
! !

!Poder methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 23:20'!
sacarEnergiaDe: unGuerrero
self subclassResponsibility.! !

Poder subclass: #Potente
	instanceVariableNames: 'potenciaDeAtaque valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Potente methodsFor: 'as yet unclassified' stamp: 'Roman 11/6/2013 15:43'!
potenciaDeAtaque
        ^ valor.! !

!Potente methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 23:47'!
puntosDeAtaque:  unGuerrero
^ unGuerrero nivelDePelea / (500 * potenciaDeAtaque)! !

!Potente methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 23:24'!
sacarEnergiaDe: unGuerrero 
^ unGuerrero cantEnergia * 0.25! !

Poder subclass: #Vengativos
	instanceVariableNames: 'aliadosVivos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Vengativos methodsFor: 'as yet unclassified' stamp: 'Roman 11/6/2013 15:44'!
puntosDeAtaque: unGuerrero 
            ^ 250 * (aliadosVivos size).! !

Object subclass: #Semilla
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

Object subclass: #Traje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

Traje subclass: #Entrenamiento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

Traje subclass: #Especial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Especial methodsFor: 'as yet unclassified' stamp: 'Daniel 11/6/2013 00:45'!
cuantoSoporta:  unGuerrero
^    0.1 + 20! !

Traje subclass: #Normal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP_DragonBallZ'!

!Normal methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 20:11'!
cuantoSoporta: untraje 
^ 0.1! !

!Traje methodsFor: 'as yet unclassified' stamp: 'Daniel 11/5/2013 20:09'!
cuantoSoporta: unTraje
 ! !
